use <sweep/sweep.scad>
use <scad-utils/shapes.scad>
$fn=6;

function shape() = circle(5);

sweep_spirograph(shape(), 200);

module sweep_spirograph(shape, radius) {
    wheels = [[0.5454545454545454, 1, 0], [0.2727272727272727, 7, 0], [0.18181818181818182, -17, 0.25]];
    step_size = 0.0014285714285714286;
    steps = 701;
    
    //Create the line data, through these awfully complicated way of writing...
    line_data = [
        for (k = [ 0 : steps]) [
            x_total(wheels, step_size*k*2*PI), 
            y_total(wheels, step_size*k*2*PI), 
            z_val(x_total(wheels, step_size*k*2*PI), y_total(wheels, step_size*k*2*PI))]
    ];
        
    sweep(shape(), construct_transform_path(line_data));
    
    //////// Spirograph Functions ////////
    function angle(wheels, index, theta) = (wheels[index][1] * theta + PI * 2 * wheels[index][2]) * 180/PI;
    
    function x_val(wheels, index, angle) = radius * wheels[index][0] * cos(angle);
    function y_val(wheels, index, angle) = radius * wheels[index][0] * sin(angle);
    function z_val(x, y) = pow(sqrt(x*x + y*y),1.5) * 0.05;
    
    function x_total(wheels, theta) = x_val(wheels, 0, angle(wheels, 0, theta)) + x_val(wheels, 1, angle(wheels, 1, theta))  + x_val(wheels, 2, angle(wheels, 2, theta)); 
    
    function y_total(wheels, theta) = y_val(wheels, 0, angle(wheels, 0, theta)) + y_val(wheels, 1, angle(wheels, 1, theta))  + y_val(wheels, 2, angle(wheels, 2, theta));

}//module sweep_spirograph

    
//function spiro_step(k) =
//    theta = step_size * k * 2 * PI;
//    x = 0;
//    y = 0;
//    //Loop over all the wheels
//    for(i = [0 : 2]) {
//        angle = (wheels[i][1] * theta + PI * 2 * wheels[i][2]) * 180/PI;
//        x = x + hex_radius * wheels[i][0] * cos(angle);
//        y = y + hex_radius * wheels[i][0] * sin(angle);
//    }//for i
//    [x,y,0,1];
////}//module spiro_step
    
